
package de.ivu.elect.presentation.email.table;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.email.entity.EmailVorlage;
import de.ivu.elect.jee.presentation.dynamictable.AbstractColumnBuilder;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;
import de.ivu.elect.presentation.email.EmailLayoutUiVisibility;

@Named(EmailVorlageColumnBuilder.COMPONENT_NAME)
public class EmailVorlageColumnBuilder extends AbstractColumnBuilder<EmailVorlage> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailVorlageColumnBuilder";

  @Inject
  private transient EmailLayoutUiVisibility emailLayoutUiVisibility;

  private AbstractEmailVorlageColumn<EmailVorlage> emailVorlageBezeichnungColumn;

  private AbstractEmailVorlageColumn<EmailVorlage> emailVorlageEmailLayoutBezeichnungColumn;

  private Boolean emailLayoutsVisible = null;

  public EmailVorlageColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    emailVorlageBezeichnungColumn = AbstractEmailVorlageColumn.createEmailVorlageBezeichnungColumn(getMessages());

    if (isEmailLayoutsVisible()) {
      emailVorlageEmailLayoutBezeichnungColumn = new EmailVorlageEmailLayoutBezeichnungColumn<>(getMessages());
    }
  }

  @Override
  protected List<ColumnEntry< ? super EmailVorlage>> getColumnEntriesSorted() {
    List<ColumnEntry< ? super EmailVorlage>> result = new ArrayList<>();

    result.add(emailVorlageBezeichnungColumn);

    if (isEmailLayoutsVisible()) {
      result.add(emailVorlageEmailLayoutBezeichnungColumn);
    }

    return result;
  }

  private boolean isEmailLayoutsVisible() {
    if (emailLayoutsVisible == null) {
      emailLayoutsVisible = emailLayoutUiVisibility.isEmailLayoutAuswahlVisible();
    }

    return emailLayoutsVisible;
  }
}
